src/Entity/Ressource.php
<?php

namespace App\Entity;

use App\Repository\RessourceRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;

/**
 * @ORM\Entity(repositoryClass=RessourceRepository::class)
 */
class Ressource
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups("ressource:read")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("ressource:read")
     */
    private $label;

    /**
     * @ORM\Column(type="string", length=255, nullable="true")
     * @Groups("ressource:read")
     */
    private $image;

    /**
     * @ORM\Column(type="text")
     * @Groups("ressource:read")
     */
    private $description;

    /**
     * @ORM\Column(type="integer")
     * @Groups("ressource:read")
     */
    private $quantity_total;

    /**
     * @ORM\ManyToMany(targetEntity=Group::class, mappedBy="ressources")
     */
    private $groups;

    /**
     * @ORM\ManyToMany(targetEntity=Category::class, mappedBy="ressources")
     */
    private $categories;

    public function __construct()
    {
        $this->groups = new ArrayCollection();
        $this->categories = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLabel(): ?string
    {
        return $this->label;
    }

    public function setLabel(string $label): self
    {
        $this->label = $label;

        return $this;
    }

    public function getImage(): ?string
    {
        return $this->image;
    }

    public function setImage(string $image): self
    {
        $this->image = $image;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getQuantityTotal(): ?int
    {
        return $this->quantity_total;
    }

    public function setQuantityTotal(int $quantity_total): self
    {
        $this->quantity_total = $quantity_total;

        return $this;
    }

    /**
     * @return Collection|Group[]
     */
    public function getGroups(): Collection
    {
        return $this->groups;
    }

    public function addGroup(Group $group): self
    {
        if (!$this->groups->contains($group)) {
            $this->groups[] = $group;
            $group->addRessource($this);
        }

        return $this;
    }

    public function removeGroup(Group $group): self
    {
        if ($this->groups->removeElement($group)) {
            $group->removeRessource($this);
        }

        return $this;
    }

    /**
     * @return Collection|Category[]
     */
    public function getCategories(): Collection
    {
        return $this->categories;
    }

    public function addCategory(Category $category): self
    {
        if (!$this->categories->contains($category)) {
            $this->categories[] = $category;
            $category->addRessource($this);
        }

        return $this;
    }

    public function removeCategory(Category $category): self
    {
        if ($this->categories->removeElement($category)) {
            $category->removeRessource($this);
        }

        return $this;
    }
}

src/Form/RessourceType.php
<?php

namespace App\Form;

use App\Entity\Ressource;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use App\Entity\Group;
use App\Entity\Category;

class RessourceType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('label')
            ->add('image')
            ->add('description')
            ->add('quantity_total')
            ->add('groups', EntityType::class, [
                'class' => Group::class,
                'choice_label' => 'label',
                'multiple' => true,
            ])
            ->add('categories', EntityType::class, [
                'class' => Category::class,
                'choice_label' => 'label',
                'multiple' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Ressource::class,
        ]);
    }
}

src/Controller/RessourceController.php
<?php

namespace App\Controller;

use App\Entity\Ressource;
use App\Form\RessourceType;
use App\Repository\RessourceRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('/ressource')]
class RessourceController extends AbstractController
{
    #[Route('/', name: 'ressource_index', methods: ['GET'])]
    public function index(RessourceRepository $ressourceRepository): Response
    {
        return $this->render('ressource/index.html.twig', [
            'ressources' => $ressourceRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'ressource_new', methods: ['GET', 'POST'])]
    public function new(Request $request, EntityManagerInterface $entityManager): Response
    {
        $ressource = new Ressource();
        $form = $this->createForm(RessourceType::class, $ressource);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($ressource);
            $entityManager->flush();

            return $this->redirectToRoute('ressource_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('ressource/new.html.twig', [
            'ressource' => $ressource,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'ressource_show', methods: ['GET'])]
    public function show(Ressource $ressource): Response
    {
        return $this->render('ressource/show.html.twig', [
            'ressource' => $ressource,
        ]);
    }

    #[Route('/{id}/edit', name: 'ressource_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Ressource $ressource, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(RessourceType::class, $ressource);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('ressource_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('ressource/edit.html.twig', [
            'ressource' => $ressource,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'ressource_delete', methods: ['POST'])]
    public function delete(Request $request, Ressource $ressource, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$ressource->getId(), $request->request->get('_token'))) {
            $entityManager->remove($ressource);
            $entityManager->flush();
        }

        return $this->redirectToRoute('ressource_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/ressource/_delete_form.html.twig
<form method="post" action="{{ path('ressource_delete', {'id': ressource.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ ressource.id) }}">
    <button class="btn">Delete</button>
</form>

templates/ressource/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/ressource/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Ressource{% endblock %}

{% block body %}
    <h1>Edit Ressource</h1>

    {{ include('ressource/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('ressource_index') }}">back to list</a>

    {{ include('ressource/_delete_form.html.twig') }}
{% endblock %}

templates/ressource/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Ressource index{% endblock %}

{% block body %}
    <h1>Ressource index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Label</th>
                <th>Image</th>
                <th>Description</th>
                <th>Quantity_total</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for ressource in ressources %}
            <tr>
                <td>{{ ressource.id }}</td>
                <td>{{ ressource.label }}</td>
                <td>{{ ressource.image }}</td>
                <td>{{ ressource.description }}</td>
                <td>{{ ressource.quantityTotal }}</td>
                <td>
                    <a href="{{ path('ressource_show', {'id': ressource.id}) }}">show</a>
                    <a href="{{ path('ressource_edit', {'id': ressource.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="6">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('ressource_new') }}">Create new</a>
{% endblock %}

templates/ressource/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Ressource{% endblock %}

{% block body %}
    <h1>Create new Ressource</h1>

    {{ include('ressource/_form.html.twig') }}

    <a href="{{ path('ressource_index') }}">back to list</a>
{% endblock %}

templates/ressource/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Ressource{% endblock %}

{% block body %}
    <h1>Ressource</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ ressource.id }}</td>
            </tr>
            <tr>
                <th>Label</th>
                <td>{{ ressource.label }}</td>
            </tr>
            <tr>
                <th>Image</th>
                <td>{{ ressource.image }}</td>
            </tr>
            <tr>
                <th>Description</th>
                <td>{{ ressource.description }}</td>
            </tr>
            <tr>
                <th>Quantity_total</th>
                <td>{{ ressource.quantityTotal }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('ressource_index') }}">back to list</a>

    <a href="{{ path('ressource_edit', {'id': ressource.id}) }}">edit</a>

    {{ include('ressource/_delete_form.html.twig') }}
{% endblock %}